DECLARE FUNCTION Ack% ()
DECLARE SUB Clock ()
DECLARE SUB Dat (D%)
DECLARE SUB Init ()
DECLARE SUB Loeschen ()
DECLARE SUB Schreibe (Text$, Z%, S%)
DECLARE SUB Sende (D%)
DECLARE SUB Start ()
DECLARE SUB Stopp ()
DECLARE SUB Warte ()
DECLARE SUB Zeichen (Nr%, M$())

CLS
PRINT " -------- Data --------     Ack"
Init
Start
Sende &H74                      'Schreibzugriff
Sende &H0                       'RS=0, R/W=0  
Sende &H2A                      '2 Zeilen, MUX 1:32, G=1
Sende &HC                       'Display on, Cursor off, Blinking off
Sende &H6                       'increment, no shift
Stopp
Loeschen                        'Clear Display
DIM M$(0 TO 7)                  'Zeichen #00 definieren
M$(0) = "00100"
M$(1) = "01010"
M$(2) = "10001"
M$(3) = "10101"
M$(4) = "10101"
M$(5) = "10001"
M$(6) = "01010"
M$(7) = "00100"
Zeichen 0, M$()
Schreibe "Testtext in Zeile 1", 1, 1
Schreibe "User defined char #00: " + CHR$(0), 2, 1

FUNCTION Ack%
  OUT &H3FB, 0
  OUT &H3FC, 0
  Warte
  Ack = (INP(&H3FE) AND 128) / 128
  OUT &H3FC, 1
  Warte

END FUNCTION

SUB Clock
  OUT &H3FC, 0
  Warte
  OUT &H3FC, 1
  Warte
END SUB

SUB Dat (D%)
  OUT &H3FB, ABS(NOT -D%) * 64
  Warte
END SUB

SUB Init
  OUT &H3FB, 0
  OUT &H3FC, 0
  Warte
END SUB

SUB Loeschen
Start
Sende &H74
Sende &H0
Sende &H1
Sende &H2
Stopp
END SUB

SUB Schreibe (Text$, Z%, S%)
Start
Sende &H74
Sende &H0
Sende 128 + (S% - 1) + (Z% - 1) * 64
Stopp
Start
Sende &H74
Sende &H40
FOR A = 1 TO LEN(Text$)
  IF MID$(Text$, A, 1) = "" THEN MID$(Text$, A, 1) = ""
  Sende ASC(MID$(Text$, A, 1))
NEXT
Stopp
END SUB

SUB Sende (D%)
  FOR A = 7 TO 0 STEP -1
    Dat ((D% AND (2 ^ A)) / (2 ^ A))
    PRINT (D% AND (2 ^ A)) / (2 ^ A);
    Clock
  NEXT
  PRINT "-->"; Ack
END SUB

SUB Start
  OUT &H3FB, 64
  Warte
  OUT &H3FC, 1
  Warte
END SUB

SUB Stopp
  OUT &H3FC, 0
  Warte
  OUT &H3FB, 0
  Warte
END SUB

SUB Warte
  FOR A = 1 TO 100
  NEXT
END SUB

SUB Zeichen (Nr%, M$())
Start
Sende &H74
Sende &H0
Sende 64 + Nr% * 8
Stopp
Start
Sende &H74
Sende &H40
FOR A = 0 TO 7
  B% = 0
  FOR C = 0 TO 4
    IF MID$(M$(A), 5 - C, 1) = "1" THEN B% = B% + 2 ^ C
  NEXT
  Sende B%
NEXT
Stopp
END SUB

